/******************************************************/
/*         ROOMS - A room 'hanging' utility.          */
/*         V 1.5                                      */
/*         (c) October 1989. L.F. Holgate             */
/*                                                    */
/*         Player info header file.                   */
/*                                                    */
/******************************************************/

struct player_info {
	char    *name, *title, *level_name, *race_name, *class_name;
	int     str, dex, con, sta, mag, siz,
		race_type, race, sex, class, level,
		senses[4],
		height, weight;
unsigned int    handedness: 2;
unsigned long   magic_exp, combat_exp, general_exp,
		max_wt, wt_car;
	} ;

struct player_idx {
	char	*name, *title;
	int     str, dex, con, sta, mag, siz,
		race_type, race, sex, class, level,
		height,weight;
unsigned int    handedness: 2;
unsigned long   magic_exp, combat_exp, general_exp;
struct player_idx *next_player;
	} ;

	/*
	Body Parts
	*/

#define HEAD             1
#define FACE             2
#define NECK             3
#define CHEST            4
#define LEFT_UPPER_ARM   5
#define LEFT_LOWER_ARM   6
#define LEFT_WRIST       7
#define LEFT_HAND        8
#define LEFT_FINGER_1    9
#define LEFT_FINGER_2   10
#define LEFT_FINGER_3   11
#define LEFT_FINGER_4   12
#define LEFT_THUMB      13
#define RIGHT_UPPER_ARM 14
#define RIGHT_LOWER_ARM 15
#define RIGHT_WRIST     16
#define RIGHT_HAND      17
#define RIGHT_FINGER_1  18
#define RIGHT_FINGER_2  19
#define RIGHT_FINGER_3  20
#define RIGHT_FINGER_4  21
#define RIGHT_THUMB     22
#define UPPER_ABDOMEN   23
#define WAIST           24
#define LOWER_ABDOMEN   25
#define LEFT_UPPER_LEG  26
#define LEFT_LOWER_LEG  27
#define LEFT_ANKLE      28
#define LEFT_FOOT       29
#define RIGHT_UPPER_LEG 30
#define RIGHT_LOWER_LEG 31
#define RIGHT_ANKLE     32
#define RIGHT_FOOT      33

	/*
	Races and Race types
	*/

#define HUMANOID	0

#define HUMAN 		0
#define ELF		1
#define DWARF		2
#define GNOME		3
#define GIANT		4
#define GOBLIN		5
#define ORC		6
#define OGRE		7
#define FAIRY		8

	/*
	class names
	*/

#define ADVENTURER	0
#define MERCENARY       1
#define SQUIRE          2
#define KNIGHT          3
#define APPRENTICE      4
#define WHITE_MAGICIAN  5
#define ILLUSIONIST     6
#define BLACK_MAGICIAN  7
#define NECROMANCER     8
