/******************************************************/
/*         ROOMS - A room 'hanging' utility.          */
/*         V 1.7                                      */
/*         (c) October 1989. L.F. Holgate             */
/*                                                    */
/*         Commands one.                              */
/*                                                    */
/******************************************************/

#include <stdio.h>
#include <alloc.h>
#include <ctype.h>
#include <string.h>
#include <ctype.h>
#include "rooms17.h"
#include "player.h"

extern struct	rm_file 	rooms[MAX_ROOMS];
extern struct	vo_file 	vocab[MAX_WORDS];
extern struct 	obj 		objects[MAX_OBJECTS];

extern	char 	*get_buffer(FILE *fp,int type),
		*get_new_command (void),
		*get_command (char *command_buffer),
		*make_list(int obj_num),
		*count_obj(char *object_list, int flg),
		*dig_to_word(int digit);

void    display_room (struct flgs *flg_ptr);

char 	*cap_first(char *in_string),
	*display_objects(int obj_num, char *buffer, int room_num, int type),
	*word_wrap(char *in_string);

int     get_name_ref (int code0,int code1,int count);

int get_name_ref(int code0, int code1, int count)
{
	while (((vocab [count].command_code[0] != code0) || (vocab [count].command_code[1] != code1)) && (vocab [count].word != NULL))
		++count;
	if (vocab [count].word == NULL) {
		printf("ERROR in vocab file, code %d, %d not found!\n",code0,code1);
		exit(1);
	}
	return (count);
}

void display_room (struct flgs *flg_ptr)
{
	int	buffer_count;
	char 	*buffer, *tmp_ldesc, *ldesc1;

	if (flg_ptr->can_see) {
		if ((buffer = farmalloc (BUFFER_SIZE *4)) == NULL)
			error (106);
		buffer[0] = 0;
                if (flg_ptr->brief_state == VERBOSE) {
			if ((tmp_ldesc = farmalloc (strlen(rooms[flg_ptr->room_num].ldesc)+1)) == NULL)
				error (107);
			strcpy(tmp_ldesc,rooms[flg_ptr->room_num].ldesc);
			if ((ldesc1 = strtok(tmp_ldesc,"|")) == NULL) {
				strcat(buffer,rooms[flg_ptr->room_num].ldesc);
			} else
				strcat(buffer,ldesc1);
			if (strlen(ldesc1) == strlen(rooms[flg_ptr->room_num].ldesc))
                        	strcat(buffer," ");
			if (rooms [flg_ptr->room_num].first_obj != 0)
				strcpy(buffer,display_objects(rooms[flg_ptr->room_num].first_obj,buffer,flg_ptr->room_num,LDESC));
			if (strlen(ldesc1) < strlen(rooms[flg_ptr->room_num].ldesc)) {
                                tmp_ldesc [strlen(ldesc1)] = '|';
				strrev(tmp_ldesc);
                                if ((ldesc1 = strtok(tmp_ldesc,"|")) == NULL)
					error(2001);
				else {
                                	strrev(ldesc1);
					strcat(buffer,ldesc1);
					tmp_ldesc [strlen(ldesc1)+1] = '|';
                                strcat(buffer," ");
				}
			}
                        if (rooms [flg_ptr->room_num].first_obj != 0 || strlen(rooms[flg_ptr->room_num].multi_room_objs) > 1)
				strcpy(buffer,display_objects(rooms[flg_ptr->room_num].first_obj,buffer,flg_ptr->room_num,FEATURE));
			farfree(tmp_ldesc);
		}
		buffer_count = strlen(buffer);
                if (rooms [flg_ptr->room_num].first_obj != 0)
			strcpy(buffer,display_objects(rooms[flg_ptr->room_num].first_obj,buffer,flg_ptr->room_num,SDESC));
		if (flg_ptr->brief_state == VERBOSE || buffer_count != strlen(buffer))
			strcat (buffer,"\n\0");
		if (flg_ptr->debug_state) {
			printf("[%3d]",flg_ptr->room_num);
			if (!strcmp(ROOM_TYPE,"NEW\n"))
				printf("\t[%3d,%3d,%3d]\n",rooms [flg_ptr->room_num].x_coord,rooms [flg_ptr->room_num].y_coord,rooms [flg_ptr->room_num].z_coord);
			else
				puts("");
		}
		printf("%s", rooms [flg_ptr->room_num].sdesc);
		printf("%s",word_wrap(buffer));
		if (flg_ptr->debug_state)
			printf("\n[%s]\n",rooms [flg_ptr->room_num].exits);
		farfree(buffer);
	} else
		printf("You can't see a thing, remember?\n");
	flg_ptr->prompt = YES;
}

char *display_objects(int obj_num, char *buffer,int room_num,int type)
{
	int 	tmp_obj_num, count, flg,
		num1_length, num2_length, num_conts;
	char 	list[COMMAND_LENGTH * 2], containers[COMMAND_LENGTH * 2],
		object_list[COMMAND_LENGTH * 2], *num_ptr, *tmp_conts,
		*capped;

	strcpy(object_list,make_list(obj_num));
	strcpy(list,count_obj(object_list,0));
	if (type == FEATURE && (strlen(rooms[room_num].multi_room_objs) > 1)) {
		if ((tmp_conts = farmalloc(strlen(rooms[room_num].multi_room_objs))) == NULL)
			exit(20);
		strcpy(tmp_conts,rooms[room_num].multi_room_objs);
		if ((num_ptr = strtok(tmp_conts,",")) == NULL)
			num_ptr = 0;
		while (num_ptr != 0) {
                	strcat(list,num_ptr);
			strcat(list,",1,");
		if ((num_ptr = strtok(NULL,",")) == NULL)
			num_ptr = 0;
		}
		farfree(tmp_conts);
	}
	if ((num_ptr = strtok(list,",")) == NULL)
		num_ptr = 0;
	obj_num = atoi(num_ptr);
        num1_length = strlen(num_ptr);
	if ((num_ptr = strtok(NULL,",")) == NULL)
		num_ptr = 0;
	count = atoi(num_ptr);
	num2_length = strlen(num_ptr);
	list[num1_length] = '|';
	list[num1_length + ++num2_length] = '|';
	strrev(list);
	list[strlen(list) - (++num1_length + num2_length)] = '\0';
	strrev(list);
	while (obj_num) {
		if (type == LDESC || type == SDESC) {
			flg = (objects[obj_num].mid_desc == type);
			if (type == SDESC)
				flg = (objects[obj_num].mid_desc == type && objects[obj_num].feature == 0);

			if (objects[obj_num].size <= TINY_OBJ && count == 1)
				if (type == LDESC)
					flg = 1;
				else
					flg = 0;
		} else
			flg = (objects[obj_num].feature == 1 && objects[obj_num].mid_desc == SDESC);
		if (objects[obj_num].is_a_door != NULL) {
		if (objects[obj_num].is_a_door->hidden_side != 0) {
			if(objects[obj_num].is_a_door->hidden_side == 1 && room_num == objects[obj_num].is_a_door->bar_side) {
				if (objects[obj_num].is_a_door->hidden_state == 1 && objects[obj_num].open_state == OPEN) {
					flg = 0;
				} else if (objects[obj_num].is_a_door->hidden_state == 1 && objects[obj_num].open_state == CLOSED) {
                                        strcat(buffer,objects[obj_num].mdesc);
					strcat(buffer," ");
					flg = 0;
				}
			} else if(objects[obj_num].is_a_door->hidden_side == 2 && room_num != objects[obj_num].is_a_door->bar_side) {
				if(objects[obj_num].is_a_door->hidden_state == 2 && objects[obj_num].open_state == CLOSED) {
					flg = 0;
				} else if (objects[obj_num].is_a_door->hidden_state == 2 && objects[obj_num].open_state == OPEN) {
                                        strcat(buffer,objects[obj_num].mdesc);
					strcat(buffer," ");
					flg = 0;
				}
			}
		}
		}
		if (flg) {
			if (count == 1)
				strcat(buffer,objects[obj_num].desc);
			else {
				strcat(buffer,(capped = cap_first(dig_to_word(count))));
				free(capped);
				strcat(buffer," ");
				strcat(buffer,objects[obj_num].mdesc);
			}
                        if (strlen(objects[obj_num].desc) > 1)
				strcat(buffer," ");
			if (objects[obj_num].openable && objects[obj_num].open_state == OPEN) {
				strcat(buffer,(capped = cap_first(objects[obj_num].theword)));
				free(capped);
				if (strlen(objects[obj_num].multi) > 1)
					strcat(buffer," are open");
				else
					strcat(buffer," is open");
				if(objects[obj_num].contains_inside != NULL && objects[obj_num].contains_inside->first != 0)
					strcat(buffer," and contains ");
				else
					strcat(buffer,". ");
			} else if (objects[obj_num].openable && objects[obj_num].open_state == CLOSED) {
				strcat(buffer,(capped = cap_first(objects[obj_num].theword)));
				free(capped);
				if (strlen(objects[obj_num].multi) > 1)
					strcat(buffer," are closed. ");
				else
					strcat(buffer," is closed. ");
			}
			if(objects[obj_num].open_state == OPEN && objects[obj_num].contains_inside != NULL && objects[obj_num].contains_inside->first != 0) {
				tmp_obj_num = obj_num;
				if (objects[obj_num].openable == NO) {
					strcat(buffer,(capped =cap_first(objects[obj_num].theword)));
					free(capped);
					strcat(buffer," contains ");
				}
				strcpy(object_list,make_list(objects[obj_num].contains_inside->first));
				strcpy(containers,count_obj(object_list,1));
				if ((tmp_conts = farmalloc(strlen(containers))) == NULL)
					error(599);
				strcpy(tmp_conts, containers);
				num_conts = 0;
				num_ptr = strtok(tmp_conts,",");
				while (num_ptr != NULL) {
					num_ptr = strtok(NULL,",");
					++num_conts;
				}
				farfree(tmp_conts);
				if ((num_ptr = strtok(containers,",")) == NULL)
					num_ptr = 0;
				obj_num = atoi(num_ptr);
				--num_conts;
				if ((num_ptr = strtok(NULL,",")) == NULL)
					num_ptr = 0;
				count = atoi(num_ptr);
                                --num_conts;
				while (obj_num) {
                                	if (count == 1)
						strcat(buffer,objects[obj_num].aword);
					else {
						strcat(buffer,dig_to_word(count));
						strcat(buffer," ");
						if (objects[obj_num].multi[0] != 0)
							strcat(buffer,objects[obj_num].multi);
						else {
							strcat(buffer,objects[obj_num].noword);
							strcat(buffer,"s");
						}
					}
                                        if ((num_ptr = strtok(NULL,",")) == NULL)
						num_ptr = 0;
					obj_num = atoi(num_ptr);
                                        --num_conts;
					if ((num_ptr = strtok(NULL,",")) == NULL)
						num_ptr = 0;
					count = atoi(num_ptr);
					--num_conts;
                                        if (obj_num){
						if (num_conts)
							strcat(buffer, ", ");
						else
							strcat(buffer," and ");
					} else
						strcat(buffer,". ");
				}
				obj_num = tmp_obj_num;
			}
		}
        	if ((num_ptr = strtok(list,",")) == NULL)
			num_ptr = 0;
		obj_num = atoi(num_ptr);
		num1_length = strlen(num_ptr);
		if ((num_ptr = strtok(NULL,",")) == NULL)
			num_ptr = 0;
		count = atoi(num_ptr);
		num2_length = strlen(num_ptr);
		list[num1_length] = '|';
		list[num1_length + ++num2_length] = '|';
		strrev(list);
		list[strlen(list) - (++num1_length + num2_length)] = '\0';
		strrev(list);
	}
	return (buffer);
}

char *cap_first(char *in_string)
{
	char 	*out_string;

	if ((out_string = malloc(strlen(in_string)+1)) == NULL)
		out_string = "ERROR";
	else
		strcpy (out_string,in_string);

	out_string[0] = toupper(out_string[0]);
	return (out_string);
}

char *word_wrap(char *buffer)
{
	int 	length, count = 0, increment = LINE_LENGTH - 2;

	length = strlen(buffer);
	for (count = increment; count < length; count += increment){
		if (!isgraph(buffer [count]) )
			buffer [count] = '\n';
		else if (isgraph(buffer [count])) {
			for (;isgraph(buffer [count]); --count);
			buffer [count++] = '\n';
		}
	}
	return (buffer);
}
