/******************************************************/
/*         ROOMS - A room 'hanging' utility.          */
/*         V 1.7                                      */
/*         (c) October 1989. L.F. Holgate             */
/*                                                    */
/*         Commands two. 			      */
/*                                                    */
/******************************************************/

#include <stdio.h>
#include <alloc.h>
#include <ctype.h>
#include <string.h>
#include <ctype.h>
#include "rooms17.h"
#include "player.h"

extern struct	rm_file 	rooms[MAX_ROOMS];
extern struct	vo_file 	vocab[MAX_WORDS];
extern struct 	obj 		objects[MAX_OBJECTS];

extern char *messages[MAX_MESSAGE];

extern	char    *show_mass(long mass),
		*get_buffer(FILE *fp,int type),
		*get_new_command (void),
		*get_command (char *command_buffer),
		*dig_to_word(int digit),
                *cap_first(char *in_string),
		*display_objects(int obj_num, char *buffer, int type),
		*word_wrap(char *in_string);

void    who(struct flgs *flg_ptr),
	scores(struct flgs *flg_ptr, struct player_info *player_ptr),
	make_a_move (struct flgs *flg_ptr),
	take_a_look (struct flgs *flg_ptr),
	display_exits (struct flgs *flg_ptr),
	brief_toggle (struct flgs *flg_ptr),
	debug_toggle (struct flgs *flg_ptr),
	teleport (struct flgs *flg_ptr),
	display_cmds (struct flgs *flg_ptr);

int     get_name_ref (int code0,int code1,int count),
	get_exit_info (char *in_string, char *dir_flg);

void who(struct flgs *flg_ptr)
{
	printf("Give me a chance will ya?\nThis will be strictly single user for quite some time yet!\n");
	flg_ptr->prompt = YES;
}

void scores(struct flgs *flg_ptr, struct player_info *player_ptr)
{
	char 	buffer[OBJ_STR_LENGTH];

	if(flg_ptr->commands[0][1] == 5) {
		printf("Name: %s",player_ptr->name);
		if (strlen(player_ptr->title) > 0)
			printf(" %s",player_ptr->title);
		printf(".\n");
		printf("Race: %s\tSex: ",player_ptr->race_name);
		if (player_ptr->sex)
			puts("Female");
		else
			puts("Male");
		printf("Profession: %s\tLevel: %d\tLevel Title: %s\n",player_ptr->class_name,player_ptr->level,player_ptr->level_name);
		printf("\nStrength:\t%4i\t\t\tGeneral Experience: \t%6li",player_ptr->str,player_ptr->general_exp);
		printf("\nDexterity:\t%4i\t\t\tMagical Experience: \t%6li",player_ptr->dex,player_ptr->magic_exp);
		printf("\nConstitution:\t%4i\t\t\tCombat Experience: \t%6li",player_ptr->con,player_ptr->combat_exp);
		printf("\nStamina:\t%4i",player_ptr->sta);
		printf("\nMagic:\t\t%4i",player_ptr->mag);
		printf("\nSize:\t\t%4i\n",player_ptr->siz);
		printf("Height:\t\t %i feet %i inches [%i mm].\n",(player_ptr->height/12),(player_ptr->height%12),(player_ptr->height*25));
		printf("Weight:\t\t %i stone %i lb ",(player_ptr->weight/14),(player_ptr->weight%14));
		strcpy(buffer,show_mass(player_ptr->weight*455l));
		printf("%s.\n",buffer);
		strcpy(buffer,"\nCarrying Capacity: ");
		strcat(buffer,show_mass(player_ptr->max_wt));
		strcat(buffer,".\nWeight Carried: ");
		strcat(buffer,show_mass(player_ptr->wt_car));
		printf("%s.\n",buffer);
		/*fatigue_factor = (float)player_ptr->wt_car/player_ptr->max_wt*100;*/
		printf ("Fatigue factor: %i%%\n",(100*player_ptr->wt_car)/player_ptr->max_wt);
	} else {
		printf("%s",player_ptr->name);
                if (strlen(player_ptr->title) > 0)
			printf(" %s",player_ptr->title);
		printf(".\n");
		printf("Str: %4i Dex: %4i Con: %4i Sta: %4i Mag: %4i Siz: %4i\n",player_ptr->str,player_ptr->dex,player_ptr->con,player_ptr->sta,player_ptr->mag,player_ptr->siz);
		strcpy(buffer,"\nCC: ");
		strcat(buffer,show_mass(player_ptr->max_wt));
		strcat(buffer,". Wt Carried: ");
		strcat(buffer,show_mass(player_ptr->wt_car));
		printf("%s.\n",buffer);
	}
	flg_ptr->prompt = YES;
}

void display_exits(struct flgs *flg_ptr)
{
	char 	*exit_tok, *exits_flg, exit_str [COMMAND_LENGTH],
		direction [COMMAND_LENGTH], tmp [COMMAND_LENGTH];
	int     count, tmp_count, ex, door_num, is_an_exit = NO;

	if (flg_ptr->can_see) {
		for (count = 1; count < 13; count++) {
			strcpy(direction, vocab [tmp_count = get_name_ref(1,count,0)].word);
			if ((exits_flg = farmalloc(strlen(vocab [get_name_ref(1,count,++tmp_count)].word))) == NULL)
				error(101);
			strcpy(exits_flg,vocab [get_name_ref(1,count,++tmp_count)].word);
			strcpy(exit_str,rooms [flg_ptr->room_num].exits);
			if((exit_tok = strtok(exit_str,",")) == NULL)
				error(102);
			while (strlen(exit_tok) > 1  && strcmp(tmp,exits_flg)) {
				sscanf (exit_tok,"%s %d",&tmp,&ex);
				if((exit_tok = strtok(NULL,",")) == NULL)
					break;
			}
			door_num = get_exit_info(rooms[flg_ptr->room_num].doors,exits_flg);
                        if (objects[door_num].open_state)
				door_num = 0;
			if (!door_num && !strcmp(tmp,exits_flg)) {
				printf("%s      \t",direction);
				if (flg_ptr->debug_state)
					printf("[%3d]  ",ex);
				if (rooms [ex].sdesc == NULL)
					printf("Not finished yet!\n");
				else
					printf("%s", rooms [ex].sdesc);
			is_an_exit = YES;
			}
			farfree(exits_flg);
		}
		if (!is_an_exit)
			printf("I guess it just isn't your lucky day, I can't see any exits here. Sorry.\n");
	} else
		printf("You can't see a thing, remember?\n");
	flg_ptr->prompt = YES;
}
void display_cmds(struct flgs *flg_ptr)
{
	puts("\t\t\tCurrently recognised commands.\n");
	puts("Look           -    Displays the room's full description.");
	puts("QuickLook      -    Displays the room's short description.");
	puts("BRief          -    Sets  your display to 'brief' mode, i.e. you recieve  only");
	puts("                    the short description of a room when you enter it.");
	puts("VERbose        -    Sets  your display to 'verbose' mode, i.e you recieve  the");
	puts("                    full description of a room when you enter it.");
	puts("SCore          \\    Not currently implemented.");
	puts("QuickScore     /");
	puts("QUIT           \\    Quits to the menu.");
	puts("QQ             /");
	puts("eXits          -    Displays all exits from the room that you occupy.");
	puts("DEBUG          -    Toggles  'debug'  mode, i.e. toggles the  display  of  the");
	puts("                    room's  number,  in square brackets, and any  other  debug");
	puts("                    information that is being used at the time.");
	puts("GOto <num>     -    Takes you directly to the room numbered <num>.");
	puts("Get <obj>      -    Picks up <obj>.");
	puts("?              \\    Displays this list.");
	puts("Help           /\n");
	puts("The movement commands: North, NorthEast, East, SouthEast, South, SouthWest,");
	puts("West, NorthWest, IN, Out, Up & Down. All move you in the direction specified.");
	flg_ptr->prompt = YES;
}

void teleport(struct flgs *flg_ptr)
{
	int tmp_rm_num = 0;

	if (flg_ptr->commands [1] [0] != 0)
		printf("You can only GO to rooms!\n");
	else
		tmp_rm_num = flg_ptr->commands [1] [1];

	if (tmp_rm_num > ROOM_NO || tmp_rm_num < 1)
		printf("Your destination room does not exist!\n"
		       "Think yourself lucky that I decided to inform you of that fact rather than\n"
		       "just spread your atoms thinly about the universe.\n");
	else
		flg_ptr->room_num = tmp_rm_num;
	flg_ptr->prompt = YES;
}

void debug_toggle(struct flgs *flg_ptr)
{
	printf("Debug mode now ");
	if (flg_ptr->debug_state) {
		flg_ptr->debug_state = OFF;
		puts("off.");
	} else {
		flg_ptr->debug_state = ON;
		puts("on.");
	}
	flg_ptr->prompt = YES;
}

void take_a_look(struct flgs *flg_ptr)
{
	int tmp;
	tmp = flg_ptr->brief_state;

	if (flg_ptr->commands[0][1] == 1)
		flg_ptr->brief_state = VERBOSE;
	else
		flg_ptr->brief_state = BRIEF;
	display_room(flg_ptr);
	flg_ptr->brief_state = tmp;
}

void brief_toggle(struct flgs *flg_ptr)
{
	if ((!flg_ptr->brief_state && flg_ptr->commands[0][1] == 4) || (flg_ptr->brief_state && flg_ptr->commands[0][1] == 3)) {
		printf("You will now receive ");
		if (!flg_ptr->brief_state && flg_ptr->commands[0][1] == 4) {
			flg_ptr->brief_state = VERBOSE;
			printf("verbose");
		} else if (flg_ptr->brief_state && flg_ptr->commands[0][1] == 3) {
			flg_ptr->brief_state = BRIEF;
			printf("brief");
		}
	} else {
		printf("You are already receiving ");
		if (flg_ptr->commands[0][1] == 4)
			printf("verbose");
		else
			printf("brief");
	}
	puts(" descriptions.");
	flg_ptr->prompt = YES;
}

void make_a_move(struct flgs *flg_ptr)
{
	int	count, new_room, message_num, dir = 0, door_num, door_message;
	char 	direction [COMMAND_LENGTH],
		*exits_flg, *capped;

	while (flg_ptr->commands [dir][0] != 1)
		dir++;
	strcpy(direction, vocab [count = get_name_ref(1,flg_ptr->commands[dir][1],0)].word);
	if ((exits_flg = farmalloc(strlen(vocab [get_name_ref(1,flg_ptr->commands[dir][1],++count)].word)+1)) == NULL)
		error(103);
	strcpy(exits_flg,vocab [get_name_ref(1,flg_ptr->commands[dir][1],++count)].word);
	new_room = get_exit_info(rooms[flg_ptr->room_num].exits,exits_flg);
	door_num = get_exit_info(rooms[flg_ptr->room_num].doors,exits_flg);
	if (objects[door_num].open_state)
		door_num = 0;
	exits_flg[0] = toupper(exits_flg[0]);
	message_num = get_exit_info(rooms[flg_ptr->room_num].exits,exits_flg);
	door_message = get_exit_info(rooms[flg_ptr->room_num].doors,exits_flg);
	if (new_room == 0 && !message_num)
		printf("You can't go %s from here!\n",direction);
	else if (new_room == -1) {
		printf("Room specified by room file does not exist!\n");
		new_room = 0;
	}
	if (door_num > 0) {
		new_room = 0;
		if (!door_message) {
			printf("Why not try using your eyes? ");
			printf("%s ",capped = cap_first(objects[door_num].theword));
			free(capped);
			if (strlen(objects[door_num].multi) < 2)
				printf("is");
			else
				printf("are");
			printf(" closed!\n");
		} else {
			if (message_num < MAX_MESSAGE && messages[door_message] != NULL)
				printf("%s\n",word_wrap(messages[door_message]));
			else
				printf("MESSAGE NOT LOADED\n");
		}
	}
	if (message_num && !door_num) {
		if (message_num < MAX_MESSAGE && messages[message_num] != NULL)
			printf("%s\n",word_wrap(messages[message_num]));
		else
			printf("MESSAGE NOT LOADED\n");
		if (new_room > 0) {
			printf(PROMPT);
			puts("");
		}
	}

	if (new_room > 0)
		flg_ptr->room_num = new_room;
	flg_ptr->prompt = YES;
	farfree(exits_flg);
}

int get_exit_info(char *in_string, char *dir_flg)
{
	char    *exit_str, *exit_ptr, tmp [10];
	int	tmp_ex;

	tmp[0] = 0;
	exit_str = strdup(in_string);
	if ((exit_ptr = strtok(exit_str,",")) == NULL)
		exit_ptr = "";
	while (strcmp(tmp,dir_flg)) {
		sscanf (exit_ptr,"%s %d",&tmp,&tmp_ex);
                if ((exit_ptr = strtok(NULL,",")) == NULL)
			break;
	}
	if (strcmp(tmp,dir_flg))
		tmp_ex = 0;
	if (tmp_ex >= 0 && (rooms [tmp_ex].sdesc == NULL))
		tmp_ex = -1;
	farfree(exit_str);
	return (tmp_ex);
}
