/******************************************************/
/*         ROOMS - A room 'hanging' utility.          */
/*         V 1.7                                      */
/*         (c) October 1989. L.F. Holgate             */
/*                                                    */
/*	   Menu and file manipulation routines.       */
/*                                                    */
/******************************************************/

#include <stdio.h>
#include <conio.h>
#include <alloc.h>
#include <dir.h>
#include <dos.h>
#include <string.h>
#include "rooms17.h"
#include "player.h"

extern struct rm_file rooms[MAX_ROOMS];
extern struct vo_file vocab[MAX_WORDS];
extern 		char *messages [MAX_MESSAGE];

extern char	*get_buffer(FILE *fp, int type),
		*word_wrap(char *in_string);


void	menu (void),
	m_options (int bright, char *option),
	load_file (void),
	put_file (void),
	merge_file (void),
	update_exits(int room_num),
	edit_file(void),
	room_info(void),
	edit_room(int room_num, int exit_line),
	edit_field(int room_num, int edit_num, int exit_line),
	edit_exits(int room_num, int exit_line, int flg);

char 	*pick_file(void);

int	show_room(int room_num);


void menu(void)
{
	char	options [7];
	int	choice, no_choice_made;

	for (;;) {
		for (choice = 6; choice > -1; choice--)
			options [choice] = YES;
		if (ROOM_FILE == NULL)
			options [2] = options [3] = options [4] = options [5] = NO;
		clrscr();
		title();
		room_info();
		m_options (options [0],"    0) Quit.");
		puts("");
		m_options (options [1],"    1) Load a room file to work from.");
		m_options (options [2],"    2) Enter the rooms.");
		m_options (options [3],"    3) Merge room files.");
		m_options (options [4],"    4) Edit room file.");
		m_options (options [5],"    5) Save an edited room file.");
		m_options (options [6],"    6) Alter TYPE of room file.");
		lowvideo();
		gotoxy(21,21);
		printf("Enter your choice:");
		printf("\n\n\t\t    Memory free: %lu bytes.\n",coreleft());
		no_choice_made = 1;
		while (no_choice_made) {
			gotoxy(41,21);
			choice = (getche() - 48);
			if (choice >= 0 || choice <= 6)
				if (options[choice] == YES)
					no_choice_made = 0;
		}
		switch (choice) {
		case 0 :
			clrscr();
			exit(0);
		case 1 :
			load_file();
                	break;
		case 2 :
			return;
		case 3 :
			merge_file();
                        break;
		case 4 :
			edit_file();
			break;
		case 5 :
			put_file();
			break;
		case 6 :
			if (ROOM_TYPE[0] == 'N')
				strcpy(ROOM_TYPE,"OLD\n");
			else
				strcpy(ROOM_TYPE,"NEW\n");
			break;
		}
	}
}

void edit_file(void)
{
	int	old_room = 0, room_num = 1, tmp, no_choice_made, options[2],
		exit_line;
	char 	choice;

	for(;;) {
		options [0] = options [1] = ON;
		if (room_num >= ROOM_NO)
			options [0] = OFF;
		if (room_num == 1)
			options[1] = OFF;
		if (old_room != room_num) {
			clrscr();
			exit_line = show_room(room_num);
			old_room = room_num;
		}
		gotoxy(1,24);
		clreol();
		if (options [0] && options [1])
			gotoxy(20,24);
		else if (options [0])
			gotoxy(25,24);
		else if (options [1])
			gotoxy(23,24);
		printf("Edit, ");
		if (options[0])
			printf("Next, ");
		if (options[1])
			printf("Previous, ");
		printf("Goto or Quit? ");
		no_choice_made = 1;
		while (no_choice_made) {
			choice = getch();
			choice = toupper(choice);
			if (choice == 'E' || (options [0] && choice == 'N') || (options [1] && choice == 'P') || choice == 'G' || choice == 'Q')
				no_choice_made = 0;
		}
		switch (choice) {
		case 'E' :
			edit_room(room_num,exit_line);
			break;
		case 'N' :
			room_num++;
			break;
		case 'P' :
			room_num--;
			break;
		case 'G' :
			gotoxy(1,24);
			clreol();
			gotoxy(25,24);
			printf("Enter room number to goto: ");
			scanf("%i",&tmp);
			getc(stdin);
			if (tmp < 1 || tmp > ROOM_NO) {
				gotoxy(1,24);
				clreol();
				gotoxy(1,24);
				printf("%c\t\t\t Not a valid room number!",7);
				sleep(1);
			} else
				room_num = tmp;
			break;
		case 'Q' :
			return;
		}
	}
}

void edit_room(int room_num,int exit_line)
{
	int 	edit_num = EXITS, no_choice_made, choice;

	for(;;) {
		gotoxy(1,3);
		if (edit_num == SDESC)
			highvideo();
		else
			lowvideo();
		cprintf("Short Description:");
		gotoxy(1,5);
		if (edit_num == LDESC)
			highvideo();
		else
			lowvideo();
		cprintf("Long Description:");
                gotoxy(1,exit_line);
		if (edit_num == EXITS)
			highvideo();
		else
			lowvideo();
		cprintf("Exits:");
		gotoxy(1,exit_line + 1);
		if (edit_num == DOORS)
			highvideo();
		else
			lowvideo();
		cprintf("Doors:");
		gotoxy(1,24);
		clreol();
		gotoxy(20,24);
		printf("Select field using cursor keys, hit return to edit.");
		no_choice_made = 1;
		while (no_choice_made) {
			choice = getch();
			if (choice == DOWN_ARROW || choice == UP_ARROW || choice == RETURN)
				no_choice_made = 0;
		}
		switch (choice) {
		case DOWN_ARROW :
			++edit_num;
			break;
		case UP_ARROW :
			--edit_num;
			break;
		case RETURN :
			edit_field(room_num,edit_num,exit_line);
			return;
		}
		if (edit_num > DOORS)
			edit_num = SDESC;
		else if (edit_num < SDESC)
			edit_num = DOORS;
	}
}

void edit_field(int room_num, int edit_num,int exit_line)
{
	int 	count;

	switch (edit_num) {
	case SDESC :
		break;
	case LDESC :
		break;
	case EXITS :
		edit_exits(room_num,exit_line,EXITS);
		gotoxy(8,exit_line);
                clreol();
		printf("%s\n",rooms[room_num].exits);
		for (count = exit_line + 2; count < (exit_line + 6); count++) {
			gotoxy(1,count);
			clreol();
		}
		break;
	case DOORS:
		edit_exits(room_num,exit_line+2,DOORS);
		gotoxy(8,exit_line);
		clreol();
		printf("%s\n",rooms[room_num].doors);
		for (count = exit_line + 2; count < (exit_line + 6); count++) {
			gotoxy(1,count);
			clreol();
		}
		break;
	}
}

void edit_exits(int room_num, int exit_line,int flg)
{
	char 	tmp [BUFFER_SIZE],
		new_string [BUFFER_SIZE];

	int	choice, no_choice_made;

	gotoxy(10,24);
	clreol();
	printf("Add to, Delete from or completely New string? [A/D/N] ");
	no_choice_made = 1;
	while (no_choice_made) {
		choice = getch();
		choice = toupper(choice);
		if (choice == 'A' || choice == 'D' || choice == 'N' )
			no_choice_made = 0;
	}
	for(;;) {
        	gotoxy(1,exit_line+2);
		switch (choice) {
		case 'A' :
			printf("Enter string to be added:");
			strcpy(tmp,get_buffer(stdin,flg));
			if (strlen(tmp) == 0)
				return;
			if (flg == EXITS)
				strcpy(new_string,rooms[room_num].exits);
			else
				strcpy(new_string,rooms[room_num].doors);
			strcat(new_string,",");
			strcat(new_string,tmp);
			break;
		/*case 'D' :
			break;*/
		case 'N' :
			printf("Enter new string:");
			strcpy(new_string,get_buffer(stdin,flg));
			if (strlen(new_string) == 0)
				return;
			break;
		}
		printf("New ");
		if (flg == EXITS)
			printf("exit");
		else
			printf("door");

		printf(" string for this room will be:\n%s\n",new_string);
		printf("Is this correct? [Y/N] ");
		no_choice_made = 1;
		while (no_choice_made) {
			choice = getch();
			choice = toupper(choice);
			if (choice == 'Y') {
				if (flg == EXITS) {
					rooms [room_num].exits = farrealloc (rooms [room_num].exits,strlen(new_string));
					strcpy(rooms [room_num].exits, new_string);
				} else {
					rooms [room_num].doors = farrealloc (rooms [room_num].doors,strlen(new_string));
					strcpy(rooms [room_num].doors, new_string);
				}
				return;
			} else if (choice == 'N')
				no_choice_made = 0;
		}
	}

}

int show_room(int room_num)
{
	char tmp_ldesc[BUFFER_SIZE];

	strcpy(tmp_ldesc,rooms[room_num].ldesc);
	printf("Room number: %i\n\nShort Description: %s\n",room_num,rooms[room_num].sdesc);
	printf("Long Description:\n%s\nExits: %s\nDoors: %s\n",word_wrap(tmp_ldesc),rooms[room_num].exits,rooms[room_num].doors);
	return(wherey()-2);
}

void merge_file(void)
{
	int	room_num, start, no_choice_made = 1;
	char 	file_name[15], tmp;
	FILE 	*fp;

	strcpy(file_name,pick_file());
	start = room_num = ROOM_NO + 1;
	if ((fp = fopen(file_name, "r")) != NULL) {
		get_buffer(fp,0);
		get_buffer(fp,0);
		for (; (get_room(fp,room_num), room_num <= MAX_ROOMS && (rooms [room_num].sdesc [0] != 0)); room_num++);
		fclose(fp);
		ROOM_NO = --room_num;
		gotoxy(21,21);
		clreol();
		printf("    Is it necessary to update the\n\t\t\texit numbering of the merged\n\t\t\tfile? [Y/N]");
		while (no_choice_made) {
			gotoxy(37,23);
			scanf("%c",&tmp);
			getchar();
			tmp = toupper(tmp);
			if (tmp == 'Y') {
				no_choice_made = 0;
				update_exits(start);
			} else if (tmp == 'N')
				no_choice_made = 0;
		}
	}
}

void update_exits(int room_num)
{
	int 	start = room_num -1,
		ex;
	char  	tmp [COMMAND_LENGTH],
		temp [COMMAND_LENGTH],
		new_exit [COMMAND_LENGTH],
		*exit_tok,
		*exit_str;

	while (room_num <= MAX_ROOMS && (rooms [room_num].sdesc [0] != 0)) {
		new_exit[0] = 0;
		if ((exit_str = malloc(strlen(rooms [room_num].exits))) == NULL)
			error(1);
		strcpy(exit_str,rooms [room_num].exits);
		if((exit_tok = strtok (exit_str,",")) == NULL)
			error(1);
		while (strlen(exit_tok) > 1) {
			if (!new_exit[0] == 0)
				strcat(new_exit,",");
			sscanf (exit_tok, "%s %d",&tmp,&ex);
			ex = ex + start;
			sprintf(temp,"%s %d",tmp,ex);
			strcat(new_exit,temp);
			if ((exit_tok = strtok (NULL,",")) == NULL)
				break;
		}
		farfree(rooms[room_num].exits);
		rooms [room_num].exits = farcalloc(sizeof(char),strlen(new_exit)+1);
		strcpy(rooms [room_num].exits,new_exit);
		room_num++;
	}

}

void put_file(void)
{
	int	count = 1;
	char 	file_name [15],file_bak [15], drive [MAXDRIVE],
		dir [MAXDIR], file[MAXFILE], ext [MAXEXT];
        FILE    *fp;

	clrscr();
	title();
        printf("\t\t    Current room file loaded: ");
	printf("%s.\n",ROOM_FILE);
	printf("\t\t    ");  		/* There MUST be a room file */
	highvideo();			/* to get this far, so there */
	cprintf("%s",ROOM_TITLE);	/* is no real need to check. */
	lowvideo();
	printf("\n\n\t\t    Enter new name for file or return\n\t\t    to use existing name: ");
	strcpy(file_name, get_buffer(stdin,3));
	if (!strcmp(file_name,""))
		strcpy(file_name,ROOM_FILE);
	fnsplit(file_name,drive,dir,file,ext);
	if (!strcmp(ext,""))
		fnmerge(file_name,drive,dir,file,".dat");
	else
		fnmerge(file_name,drive,dir,file,ext);
	printf("\n\t\t    Saving edited file: %s",ROOM_FILE);
	if (strcmp(ROOM_FILE,file_name))
		printf(", as %s.\n",file_name);
	else {
		puts(".");
                fnmerge(file_bak,drive,dir,file,".bak");
		rename(file_name,file_bak);
		printf("\t\t    existing file renamed: %s.\n",file_bak);
	}
	strcpy(ROOM_FILE,file_name);
	if ((fp = fopen(file_name, "w")) == NULL) {
		fclose(fp);
		puts("\n\n\t\t    ERROR opening output file!");
		exit(1);
	}
	fprintf(fp,"%s%s",ROOM_TITLE,ROOM_TYPE);
	while (rooms[count].sdesc != NULL && rooms[count].sdesc[0] != 0) {
		fprintf(fp,"%s",rooms[count].sdesc);
		if (rooms[count].ldesc [0] != NULL)
			fprintf (fp,"%s\n*\n%s",rooms[count].ldesc,rooms[count].exits);
		else
			fprintf (fp,"[blank]\n*\n%s",rooms[count].exits);
		if (strlen(rooms[count].doors) > 1)
			fprintf (fp,"|%s\n",rooms[count].doors);
		else
			fprintf (fp,"\n");
		if (!strcmp(ROOM_TYPE,"NEW\n"))
			fprintf(fp,"%i,%i,%i\n",rooms[count].x_coord,rooms[count].y_coord,rooms[count].z_coord);
		count++;
	}
	fclose(fp);
}

void load_file(void)
{
	char	file_name[15];

	strcpy(file_name,pick_file());
	if (strcmp(file_name,NULL)) {
		init_rooms();
		read_rooms(file_name);
		init_messages();
		read_messages();
		init_objs();
		read_objs();
	}

}

char *pick_file(void)
{

	struct	ffblk ffblk;
	char 	file_name[15], drive [MAXDRIVE], dir [MAXDIR],
		file[MAXFILE], ext [MAXEXT];
	int	done, flg = 0;
	FILE    *fp;

	clrscr();
	title();
	puts("\t\t\tData files available.");
	done = findfirst("*.dat",&ffblk,0);
	while(!done) {
		if (!flg) {
			printf("\n\t\t");
			flg = 2;
		}
		printf("\t%-15s",ffblk.ff_name);
		done = findnext(&ffblk);
		--flg;
	}
	gotoxy(21,21);
	printf("Enter name of file to load: ");
	scanf("%13s",&file_name);
	getc(stdin);
	fnsplit(file_name,drive,dir,file,ext);
	if (strcmp(ext,".dat"))
		fnmerge(file_name,drive,dir,file,".dat");
	if ((fp = fopen(file_name, "r")) == NULL) {
		fclose(fp);
		printf("\n\n\t\t\tFile not found!\n\n\t\t\tPress any key to continue.");
		getchar();
		return(NULL);
	}
	fclose(fp);
	return (file_name);
}

void m_options(int bright, char *option)
{
	if (bright)
		highvideo();
	else
		lowvideo();
	printf("\t\t");
	cprintf("%s",option);
	puts("");
}
void room_info(void)
{
	printf("\t\t    Current room file loaded:");
	if (ROOM_FILE != NULL) {
		printf("%s.\n",ROOM_FILE);
		printf("\t\t    ");
		highvideo();
		cprintf("%s",ROOM_TITLE);
		lowvideo();
		puts("");
	} else
		puts("None.\n");
}