/******************************************************/
/*         ROOMS - A room 'hanging' utility.          */
/*         V 1.7                                      */
/*         (c) October 1989. L.F. Holgate             */
/*                                                    */
/*         Object manipulation routines 1.            */
/*         Take, Drop, Open/Close and Empty           */
/*                                                    */
/******************************************************/

#include <stdio.h>
#include <alloc.h>
#include <ctype.h>
#include <string.h>
#include "rooms17.h"
#include "player.h"

extern struct 	rm_file 	rooms[MAX_ROOMS];
extern struct	vo_file 	vocab[MAX_WORDS];
extern struct 	obj 		objects[MAX_OBJECTS];
extern struct 	player_info 	player, *player_ptr;
extern struct   flgs		flag, *flg_ptr;
extern struct   inv		inventory, *inv_ptr;

extern 	char 	*cap_first(char *in_file),
		*word_wrap(char *in_file),
		*is_it_here(int type,char classes[][5][COMMAND_LENGTH],int known[][5],int near_miss[][5],int obj_ref[],int obj_num[]),
                *make_list(int start),
		*count_obj(char object_list[], int flg),
		*dig_to_word(int digit),
                *show_obj(char all[],char list[],char *buffer,int flag,int or);

void	empty_object(struct flgs *flg_ptr, struct inv *inv_ptr, struct player_info *player_ptr),
	open_close(struct flgs *flg_ptr, struct inv *inv_ptr,int flag),
	get_object(struct flgs *flg_ptr, struct inv *inv_ptr, struct player_info *player_ptr),
	drop_object(struct flgs *flg_ptr, struct inv *inv_ptr, struct player_info *player_ptr);

void get_object(struct flgs *flg_ptr, struct inv *inv_ptr, struct player_info *player_ptr)
{
	int 	obj_num[2], obj_ref[2], misc[2],
		near_miss[2][5], known[2][5], obj_count, feature = NO,
		nothing_taken = YES, in_a_container, first_last[2][2];
	char 	classes[2][5][COMMAND_LENGTH],*buffer,
		move_these[OBJ_STR_LENGTH], all_of_them[OBJ_STR_LENGTH],
		taken_list[OBJ_STR_LENGTH], not_taken_list[OBJ_STR_LENGTH];

	move_these[0] = all_of_them[0] = taken_list[0] = not_taken_list[0] = 0;
	object_manip(TAKE_OBJ,flg_ptr,inv_ptr,known,near_miss,classes,obj_num,obj_ref,move_these,misc);
	strcpy(all_of_them,count_obj(move_these,1));
	if (misc[0] == -1)
		return;
	in_a_container = misc[0];
	obj_count = misc[1];
	obj_num[OBJECT] = front_obj(move_these);
	while(obj_num[OBJECT]) {
                if(in_a_container) {
			OLD_FIRST = objects[obj_num[CONTAINER]].contains_inside->first;
			OLD_LAST = objects[obj_num[CONTAINER]].contains_inside->last;
		} else {
			OLD_FIRST = rooms[flg_ptr->room_num].first_obj;
			OLD_LAST = rooms[flg_ptr->room_num].last_obj;
		}
		NEW_FIRST = inv_ptr->first;
		NEW_LAST = inv_ptr->last;
		if(objects[obj_num[OBJECT]].feature)
			feature = obj_num[OBJECT];
		else if (objects[obj_num[CONTAINER]].loc_type != HELD &&
		(player_ptr->wt_car + objects[obj_num[OBJECT]].mass + (objects[obj_num[OBJECT]].contains_inside != NULL ? objects[obj_num[OBJECT]].contains_inside->contained_wt : 0)
		> player_ptr->max_wt))
			add_dig_to_string(not_taken_list,obj_num[OBJECT],1);
		else {
			move_object(first_last,obj_num[OBJECT]);
			obj_count--;
			if(in_a_container) {
				objects[obj_num[CONTAINER]].contains_inside->first = OLD_FIRST;
				objects[obj_num[CONTAINER]].contains_inside->last = OLD_LAST;
				add_dig_to_string(taken_list,obj_num[OBJECT],1);
				objects[obj_num[CONTAINER]].contains_inside->contained_wt -= objects[obj_num[OBJECT]].mass;
				if (objects[obj_num[CONTAINER]].loc_type != HELD) {
					player_ptr->wt_car += objects[obj_num[OBJECT]].mass;
					if (objects[obj_num[OBJECT]].contains_inside != NULL)
						player_ptr->wt_car += objects[obj_num[OBJECT]].contains_inside->contained_wt;
				}
			} else {
				rooms[flg_ptr->room_num].first_obj = OLD_FIRST;
				rooms[flg_ptr->room_num].last_obj = OLD_LAST;
				add_dig_to_string(taken_list,obj_num[OBJECT],1);
                        	player_ptr->wt_car += objects[obj_num[OBJECT]].mass;
				if (objects[obj_num[OBJECT]].contains_inside != NULL)
					player_ptr->wt_car += objects[obj_num[OBJECT]].contains_inside->contained_wt;
			}
			objects[obj_num[OBJECT]].loc_type = HELD;
			objects[obj_num[OBJECT]].location = 0;
			inv_ptr->first = NEW_FIRST;
			NEW_LAST = inv_ptr->last = NEW_LAST;
			}
                obj_num[OBJECT] = front_obj(move_these);
		if (obj_count == 0)
			break;
	}
	if (strlen(taken_list) != 0) {
		if ((buffer = farmalloc (BUFFER_SIZE)) == NULL)
			error(501);
		buffer[0] = 0;
		if (in_a_container)
			strcpy(buffer,"You remove ");
		else
			strcpy(buffer,"You pick up ");
		strcpy(taken_list,count_obj(taken_list,1));
		show_obj(all_of_them,taken_list,buffer,1,0);
		if (in_a_container) {
			strcat(buffer," from ");
			strcat(buffer,objects[obj_num[CONTAINER]].theword);
		}
		strcat(buffer,".\n");
		printf("%s",word_wrap(buffer));
		farfree(buffer);
		nothing_taken = NO;
	}
	if (strlen(not_taken_list) != 0) {
		strcpy(not_taken_list,count_obj(not_taken_list,1));
                if ((buffer = farmalloc (BUFFER_SIZE)) == NULL)
			error(501);
		buffer[0] = 0;
		strcat(buffer,"Unfortunately you can't take the weight of ");
		show_obj(all_of_them,not_taken_list,buffer,1,1);
		strcat(buffer,".\n");
		printf("%s",word_wrap(buffer));
		farfree(buffer);
		nothing_taken = NO;
	}
	flg_ptr->prompt = YES;
	if(nothing_taken && feature) {
			if ((buffer = farmalloc (COMMAND_LENGTH * 2)) == NULL)
				error(501);
			buffer[0] = 0;
			strcat(buffer,"What gives you the idea that ");
			strcat(buffer,objects[feature].theword);
			strcat(buffer," can just be picked up and taken away?\n\0");
			printf("%s",word_wrap(buffer));
			farfree(buffer);
	} else if (nothing_taken)
		manip_error(TAKE_OBJ,OBJECT,classes,known,near_miss,obj_ref);
}

void drop_object(struct flgs *flg_ptr, struct inv *inv_ptr, struct player_info *player_ptr)
{
	int 	obj_num[2], obj_ref[2], misc[2],
		near_miss[2][5], known[2][5], obj_count,
		nothing_dropped = YES, in_a_container, first_last[2][2];
	char 	classes[2][5][COMMAND_LENGTH], *buffer,
		move_these[OBJ_STR_LENGTH], all_of_them[OBJ_STR_LENGTH],
		dropped_list[OBJ_STR_LENGTH], not_dropped_list[OBJ_STR_LENGTH];

	move_these[0] = all_of_them[0] = dropped_list[0] = not_dropped_list[0] = 0;
	object_manip(DROP_OBJ,flg_ptr,inv_ptr,known,near_miss,classes,obj_num,obj_ref,move_these,misc);
	strcpy(all_of_them,count_obj(move_these,1));
	if (misc[0] == -1)
		return;
	in_a_container = misc[0];
	obj_count = misc[1];
	obj_num[OBJECT] = front_obj(move_these);
	while(obj_num[OBJECT]) {
                if(in_a_container) {
			NEW_FIRST = objects[obj_num[CONTAINER]].contains_inside->first;
			NEW_LAST = objects[obj_num[CONTAINER]].contains_inside->last;
			objects[obj_num[OBJECT]].loc_type = 1;
			objects[obj_num[OBJECT]].location = obj_num[CONTAINER];
		} else {
			NEW_FIRST = rooms[flg_ptr->room_num].first_obj;
			NEW_LAST = rooms[flg_ptr->room_num].last_obj;
			objects[obj_num[OBJECT]].loc_type = 0;
			objects[obj_num[OBJECT]].location = flg_ptr->room_num;
		}
		OLD_FIRST = inv_ptr->first;
		OLD_LAST = inv_ptr->last;
		move_object(first_last,obj_num[OBJECT]);
		obj_count--;
		if(in_a_container) {
			objects[obj_num[CONTAINER]].contains_inside->first = NEW_FIRST;
			objects[obj_num[CONTAINER]].contains_inside->last = NEW_LAST;
			add_dig_to_string(dropped_list,obj_num[OBJECT],1);
			objects[obj_num[CONTAINER]].contains_inside->contained_wt += objects[obj_num[OBJECT]].mass;
			if (objects[obj_num[CONTAINER]].loc_type != HELD) {
				player_ptr->wt_car -= objects[obj_num[OBJECT]].mass;
				if (objects[obj_num[OBJECT]].contains_inside != NULL)
					player_ptr->wt_car -= objects[obj_num[OBJECT]].contains_inside->contained_wt;
			}
		} else {
			rooms[flg_ptr->room_num].first_obj = NEW_FIRST;
			rooms[flg_ptr->room_num].last_obj = NEW_LAST;
			add_dig_to_string(dropped_list,obj_num[OBJECT],1);
			player_ptr->wt_car -= objects[obj_num[OBJECT]].mass;
			if (objects[obj_num[OBJECT]].contains_inside != NULL)
				player_ptr->wt_car -= objects[obj_num[OBJECT]].contains_inside->contained_wt;
		}
		inv_ptr->first = OLD_FIRST;
		NEW_LAST = inv_ptr->last = OLD_LAST;
		nothing_dropped = NO;
		do
                	obj_num[OBJECT] = front_obj(move_these);
		while(obj_num[OBJECT] == obj_num[CONTAINER] && obj_num[OBJECT]);
		if (obj_count == 0)
			break;
	}
	if (strlen(dropped_list) != 0) {
		if ((buffer = farmalloc (BUFFER_SIZE)) == NULL)
			error(501);
		buffer[0] = 0;
		if (in_a_container)
			strcpy(buffer,"You insert ");
		else
			strcpy(buffer,"You drop ");
		strcpy(dropped_list,count_obj(dropped_list,1));
		show_obj(all_of_them,dropped_list,buffer,1,0);
		if (in_a_container) {
			strcat(buffer," into ");
			strcat(buffer,objects[obj_num[CONTAINER]].theword);
		}
		strcat(buffer,".\n");
		printf("%s",word_wrap(buffer));
	}

	flg_ptr->prompt = YES;
	if (nothing_dropped)
		manip_error(DROP_OBJ,OBJECT,classes,known,near_miss,obj_ref);

}

void empty_object(struct flgs *flg_ptr, struct inv *inv_ptr, struct player_info *player_ptr)
{
	int 	obj_num[2], obj_ref[2], misc[2], near_miss[2][5],
		known[2][5], nothing_emptied = YES, obj_emptied,
		into_a_container, tmp_obj_num_1, next_obj, first_last[2][2];
	char 	classes[2][5][COMMAND_LENGTH], move_these[OBJ_STR_LENGTH],
		*capped;

	move_these[0] = 0;
	object_manip(EMPTY_OBJ,flg_ptr,inv_ptr,known,near_miss,classes,obj_num,obj_ref,move_these,misc);
	if (misc[0] == -1)
		return;
	into_a_container = misc[0];
	obj_num[OBJECT] = front_obj(move_these);
	while(obj_num[OBJECT]) {
		obj_emptied = NO;
		if (objects[obj_num[OBJECT]].contains_inside != NULL && objects[obj_num[OBJECT]].open_state) {
			tmp_obj_num_1 = obj_num[OBJECT];
			obj_num[OBJECT] = objects[obj_num[OBJECT]].contains_inside->first;
			while (obj_num[OBJECT]) {
				next_obj = objects[obj_num[OBJECT]].next_obj;
				if(into_a_container) {
					NEW_FIRST = objects[obj_num[CONTAINER]].contains_inside->first;
					NEW_LAST = objects[obj_num[CONTAINER]].contains_inside->last;
					objects[obj_num[OBJECT]].loc_type = 1;
					objects[obj_num[OBJECT]].location = obj_num[CONTAINER];
				} else {
					NEW_FIRST = rooms[flg_ptr->room_num].first_obj;
					NEW_LAST = rooms[flg_ptr->room_num].last_obj;
					objects[obj_num[OBJECT]].loc_type = 0;
					objects[obj_num[OBJECT]].location = flg_ptr->room_num;
				}
				OLD_FIRST = objects[tmp_obj_num_1].contains_inside->first;
				OLD_LAST = objects[tmp_obj_num_1].contains_inside->last;
				move_object(first_last,obj_num[OBJECT]);
				if(into_a_container) {
					objects[obj_num[CONTAINER]].contains_inside->first = NEW_FIRST;
					objects[obj_num[CONTAINER]].contains_inside->last = NEW_LAST;
					objects[obj_num[CONTAINER]].contains_inside->contained_wt += objects[obj_num[OBJECT]].mass;
					if (objects[obj_num[CONTAINER]].loc_type != HELD)
						player_ptr->wt_car -= objects[obj_num[OBJECT]].mass;
					objects[tmp_obj_num_1].contains_inside->contained_wt -= objects[obj_num[OBJECT]].mass;
				} else {
					rooms[flg_ptr->room_num].first_obj = NEW_FIRST;
					rooms[flg_ptr->room_num].last_obj = NEW_LAST;
					player_ptr->wt_car -= objects[obj_num[OBJECT]].mass;
                                        objects[tmp_obj_num_1].contains_inside->contained_wt -= objects[obj_num[OBJECT]].mass;
				}
				objects[tmp_obj_num_1].contains_inside->first = OLD_FIRST;
				NEW_LAST = objects[tmp_obj_num_1].contains_inside->last = OLD_LAST;
				nothing_emptied = NO;
				obj_emptied = YES;
				obj_num[OBJECT] = next_obj;
			}
			obj_num[OBJECT] = tmp_obj_num_1;
			if (obj_emptied) {
				printf("%s emptied",capped = cap_first(objects[obj_num[OBJECT]].noword));
				free(capped);
				if (into_a_container)
					printf(" into %s",objects[obj_num[CONTAINER]].theword);
				puts(".");
			} else {
				printf("%s is already empty!\n",capped = cap_first(objects[obj_num[OBJECT]].theword));
				free(capped);
				nothing_emptied = NO;
			}
		} else if (objects[obj_num[OBJECT]].contains_inside != NULL && !objects[obj_num[OBJECT]].open_state) {
			printf("How do you expect to empty %s when it is closed?\n",objects[obj_num[OBJECT]].theword);
			nothing_emptied = NO;
		}
		obj_num[OBJECT] = front_obj(move_these);
	}
	flg_ptr->prompt = YES;
	if (nothing_emptied)
		manip_error(EMPTY_OBJ,OBJECT,classes,known,near_miss,obj_ref);
}

void open_close(struct flgs *flg_ptr, struct inv *inv_ptr,int flag)
{
	int 	obj_num[2], obj_ref[2], misc[2], near_miss[2][5],
		known[2][5], obj_count, nothing_opened = YES,
		using_something, last_obj = 0;
	char 	classes[2][5][COMMAND_LENGTH], open_these[OBJ_STR_LENGTH],
		*capped;

	open_these[0] = 0;
	object_manip(flag,flg_ptr,inv_ptr,known,near_miss,classes,obj_num,obj_ref,open_these,misc);
	if (misc[0] == -1)
		return;
	using_something = misc[0];
	++using_something;  /* in so that open door f key will work */
	--using_something;
	obj_count = misc[1];
	obj_num[OBJECT] = front_obj(open_these);
	last_obj = 0;
	while(obj_num[OBJECT]) {
		if (objects[obj_num[OBJECT]].openable == YES) {
			if (flag == OPEN_OBJ) {
				if (objects[obj_num[OBJECT]].open_state == YES){
					printf("%s ",capped = cap_first(objects[obj_num[OBJECT]].theword));
                                        free(capped);
					if (strlen(objects[obj_num[OBJECT]].multi) < 2)
						printf("is");
					else
						printf("are");
					printf(" already open.\n");
				} else {
					objects[obj_num[OBJECT]].open_state = YES;
					printf("%s creak",capped = cap_first(objects[obj_num[OBJECT]].theword));
                                        free(capped);
					if (strlen(objects[obj_num[OBJECT]].multi) < 2)
						printf("s");
					printf(" open.\n");
					obj_count--;
				}
			} else {
				if (objects[obj_num[OBJECT]].open_state == NO) {
					printf("%s ",capped = cap_first(objects[obj_num[OBJECT]].theword));
                                        free(capped);
					if (strlen(objects[obj_num[OBJECT]].multi) < 2)
						printf("is");
					else
						printf("are");
					printf(" already closed.\n");
				} else {
					objects[obj_num[OBJECT]].open_state = NO;
					printf("%s creak",capped = cap_first(objects[obj_num[OBJECT]].theword));
                                        free(capped);
					if (strlen(objects[obj_num[OBJECT]].multi) < 2)
						printf("s");
					printf(" shut.\n");
                                        obj_count--;
				}
			}
			nothing_opened = NO;
		}
		last_obj = obj_num[OBJECT];
                obj_num[OBJECT] = front_obj(open_these);
		if (obj_count == 0)
			break;
	}
        flg_ptr->prompt = YES;
	if (nothing_opened) {
		if (known[OBJECT][obj_ref[OBJECT]] && (objects[last_obj].contains_inside == NULL || objects[last_obj].openable == 0)) {
			printf("Don't be silly, how can you ");
			manip_type(flag,1);
			printf(" %s.\n",objects[last_obj].aword);
		} else
			manip_error(flag,OBJECT,classes,known,near_miss,obj_ref);
	}
}
