/******************************************************/
/*         ROOMS - A room 'hanging' utility.          */
/*         V 1.7                                      */
/*         (c) October 1989. L.F. Holgate             */
/*                                                    */
/*         Object manipulation routines 4.            */
/*         Miscellaneous object routines.             */
/*                                                    */
/******************************************************/

#include <stdio.h>
#include <alloc.h>
#include <ctype.h>
#include <string.h>
#include "rooms17.h"
#include "player.h"

extern struct 	rm_file 	rooms[MAX_ROOMS];
extern struct 	vo_file 	vocab[MAX_WORDS];
extern struct 	obj 		objects[MAX_OBJECTS];
extern struct 	player_info 	player, *player_ptr;
extern struct   flgs		flag, *flg_ptr;
extern struct   inv		inventory, *inv_ptr;

extern 	char 	*word_wrap(char *in_file),
		*dig_to_word(int digit);

void	move_object(int first_last[][2],int obj_num),
	get_classes(struct flgs *flg_ptr,char classes[][5][COMMAND_LENGTH],int obj_ref[]),
	a_near_miss(int type,int known[][5], int near_miss[][5], int obj_ref[]),
	object_manip(int manip, struct flgs *flg_ptr, struct inv *inv_ptr, int known[][5], int near_miss[][5], char classes[][5][COMMAND_LENGTH], int obj_num[], int obj_ref[], char move_these[], int misc[]),
	manip_error(int manip,int type, char classes[][5][COMMAND_LENGTH], int known[][5], int near_miss[][5], int obj_ref[]);

int     is_it_known(int type,char classes[][5][COMMAND_LENGTH],int known[][5],int obj_ref[],int obj_num[]);

char 	*is_it_here(int type,char classes[][5][COMMAND_LENGTH],int known[][5],int near_miss[][5],int obj_ref[],int obj_num[]),
	*add_types(int obj_num,char *tmp_type);

void manip_error(int manip, int type, char classes[][5][COMMAND_LENGTH], int known[][5], int near_miss[][5], int obj_ref[])
{
	int	first_class, count;

	if (!known[type][obj_ref[type]] && !near_miss[type][obj_ref[type]]) {
		printf("I know what you want to ");
		manip_type(manip,1);
		if (manip != DROP_OBJ && manip != WEIGH_OBJ && manip != EMPTY_OBJ) {
			if (obj_ref[CONTAINER] != -1)
				printf(" but there aren't any in there.\n");
			else
				printf(" but there aren't any here.\n");
		} else
			printf(" but you aren't carrying any.\n");
	} else if (near_miss[type][obj_ref[type]]) {
		if (type == OBJECT) {
			printf("I would ");
			if (obj_ref[CONTAINER] != -1)
				manip_type(manip,2);
			else
				manip_type(manip,1);
			printf(" the %s",classes[type][obj_ref[type]]);
			if (obj_ref[CONTAINER] != -1) {
				manip_type(manip,3);
				printf(" the %s,",classes[CONTAINER][obj_ref[CONTAINER]]);
			} else
				printf(",");
			printf(" but it isn\'t ");
		} else
			printf ("The only %s that's here isn't ",classes[type][obj_ref[type]]);
		first_class = YES;
		for(count = 0; count <= obj_ref[type]; count++) {
			if(!near_miss[type][count]) {
				if(!first_class)
					printf(" or ");
				printf("%s",classes[type][count]);
				first_class = NO;
			}
		}
		puts(".");
	} else
		puts("{test} I don't see the direct object you gave in your command.");
}

void move_object(int first_last[][2],int obj_num)
{
	if (OLD_LAST == obj_num)
		OLD_LAST = objects [obj_num].prev_obj;
	else
		objects [objects [obj_num].next_obj].prev_obj = objects [obj_num].prev_obj;

	if (OLD_FIRST == obj_num)
		OLD_FIRST = objects [obj_num].next_obj;
	else
		objects [objects [obj_num].prev_obj].next_obj = objects [obj_num].next_obj;
	if (NEW_FIRST == 0) {
		NEW_FIRST = obj_num;
		objects[obj_num].prev_obj = 0;
	} else {
		objects[NEW_LAST].next_obj = obj_num;
		objects[obj_num].prev_obj = NEW_LAST;
	}
	NEW_LAST = obj_num;
	objects [obj_num].next_obj = 0;
}

char *is_it_here(int type,char classes[][5][COMMAND_LENGTH],int known[][5],int near_miss[][5],int obj_ref[],int obj_num[])
{
	int	found_one = NO, tmp_obj_num, count;
	char 	these_match[OBJ_STR_LENGTH], tmp[10];

	these_match[0] = 0;
	while (obj_num[type]) {
		while (obj_num[type]) {
			tmp_obj_num = is_it_known(type,classes,known,obj_ref,obj_num);
			for(count = 0; count <= obj_ref[type]; count++) {
				if(known[type][count])
					found_one = YES;
			}
			for(count = 0; count <= obj_ref[type]; count++) {
				if (!known[type][count]) {
					found_one = NO;
					a_near_miss(type,known,near_miss,obj_ref);
				}
			}
			if (found_one || known[type][obj_ref[type]])
				break;
			obj_num[type] = tmp_obj_num;
		}
		if(found_one && (obj_num[OBJECT] == obj_num[CONTAINER]))
			found_one = NO;
		if(found_one) {
			itoa(obj_num[type],tmp,10);
			strcat(these_match,tmp);
			strcat(these_match,",");
			if (type == CONTAINER)
				break;
		}
		obj_num[type] = tmp_obj_num;
	}
	return(these_match);
}

void a_near_miss(int type,int known[][5], int near_miss[][5],int obj_ref[])
{
	int	nr_miss, knwn, count;

	nr_miss = knwn = 0;
	for (count = 0; count < 5; count++) {
		if (known[type][count])
			knwn++;
		if (near_miss[type][count])
			nr_miss++;
	}
	if (nr_miss <= knwn && known[type][obj_ref[type]])
		for (count = 0; count <= 4; count++) {
			near_miss[type][count] = known[type][count];
		}
}

void get_classes(struct flgs *flg_ptr,char classes[][5][COMMAND_LENGTH],int obj_ref[])
{
	int count1, count2, tmp_ref;

	for(count1 = 0; count1 < 2; count1++) {
		for(count2 = 0; count2 < COMMAND_LIMIT;) {
			if (flg_ptr->commands[obj_ref[count1]][0] == -1)
				break;
			tmp_ref = get_name_ref(flg_ptr->commands[obj_ref[count1]][0],flg_ptr->commands[obj_ref[count1]][1],0);
			if (flg_ptr->commands[obj_ref[count1]][0] == 4) {
				strcpy(classes[count1][count2],vocab[tmp_ref].word);
				++count2;
			}
			if (flg_ptr->commands[obj_ref[count1]+1][1] == -1 || flg_ptr->commands[obj_ref[count1]+1][0] == 3)
				break;
			++obj_ref[count1];
		}
		if (!count1)
			obj_ref[CONTAINER] = ++obj_ref[OBJECT];
		obj_ref[count1] = --count2;
	}
}

int is_it_known(int type,char classes[][5][COMMAND_LENGTH],int known[][5],int obj_ref[],int obj_num[])
{
	int 	count, length, tmp_obj_num;
	char 	*tmp_type, *obj_ptr, tmp[COMMAND_LENGTH];

	for (count = 0; count <= obj_ref[type]; count++) {
		known[type][count] = NO;
		if ((tmp_type = farmalloc (strlen(objects[obj_num[type]].type)+1)) == NULL)
			error(601);
		strcpy(tmp_type,objects[obj_num[type]].type);
		tmp_type = add_types(obj_num[type],tmp_type);
		length = strlen(tmp_type);
		if ((obj_ptr = strtok (tmp_type,",")) == NULL)
			exit(1);
		strcpy(tmp,obj_ptr);
		while (length) {
			if (!strcmp(tmp,classes[type][count]) || !strcmp("all",classes[type][count])) {
				known[type][count] = YES;
				break;
			}
			length -= strlen(tmp);
			if (length) {
				if ((obj_ptr = strtok (NULL,",")) == NULL)
					break;
				strcpy(tmp,obj_ptr);
				length--;
			}
		}
		farfree(tmp_type);
		tmp_obj_num = objects[obj_num[type]].next_obj;
	}
	return (tmp_obj_num);
}

char *add_types(int obj_num,char *tmp_type)
{
	char *new_type;
	if ((new_type = farmalloc (OBJ_STR_LENGTH)) == NULL)
		error(1901);
	strcpy(new_type,tmp_type);
	if (objects[obj_num].is_a_door != NULL)
		strcat(new_type,",door");
	if (objects[obj_num].contains_inside != NULL)
		strcat(new_type,",container");
	if (objects[obj_num].openable && objects[obj_num].open_state)
		strcat(new_type,",open");
	if (objects[obj_num].openable && !objects[obj_num].open_state)
		strcat(new_type,",closed");
	if (objects[obj_num].lockable && objects[obj_num].lock_state)
		strcat(new_type,",locked");
	if (objects[obj_num].lockable && !objects[obj_num].lock_state)
		strcat(new_type,",unlocked");
	if ((objects[obj_num].contains_inside != NULL && objects[obj_num].contains_inside->first == 0)|| (objects[obj_num].openable && !objects[obj_num].open_state))
		strcat(new_type,",empty");

	if ((tmp_type = farrealloc (tmp_type,strlen(new_type)+1)) == NULL)
			error(901);
	strcpy(tmp_type,new_type);
	farfree(new_type);
	return(tmp_type);
}

void object_manip(int manip, struct flgs *flg_ptr, struct inv *inv_ptr, int known[][5], int near_miss[][5], char classes[][5][COMMAND_LENGTH], int obj_num[], int obj_ref[], char move_these[], int misc[])
{
	int 	count, obj_count, in_a_container, type, length, length2,
		tmp_next;

	char 	*multi_string, *multi_ptr;

	for (count = 0; count < 5; count++) {
		known[0][count] = near_miss[0][count] = classes[0][count][0] = 0;
		known[1][count] = near_miss[1][count] = classes[1][count][0] = 0;
	}
	obj_count = 32767;
	obj_ref[CONTAINER] = obj_ref[OBJECT] = obj_num [CONTAINER] = obj_num[OBJECT] = 0;
	if (flg_ptr->commands[1][0] == 4) 		/* <cmd> <OBJ> */
		obj_ref[OBJECT] = 1;
	else if (flg_ptr->commands[1][0] == 0) {
		obj_count = flg_ptr->commands[1][1]; 	/* <cmd> <NUM> <OBJ> */
		if (flg_ptr->commands[2][0] == 4)
			obj_ref[OBJECT] = 2;
		else {
			printf("You want to ");
			manip_type(manip,1);
			printf(" %s of what?\n",dig_to_word(obj_count));
			/*
			strcpy(print_buffer,dig_to_word(obj_count));
			strcat(print_buffer," of what?\n");
			printf("%s",print_buffer);
			*/
			flg_ptr->prompt = YES;
			misc[0] = -1;
			return;
		}
		if (!obj_count) {
			printf("Don't be silly, how can you ");
			manip_type(manip,1);
			printf(" none of something?\n");
			flg_ptr->prompt = YES;
			misc[0] = -1;
			return;
		}
	} else {
		printf("Ok, how about telling me what it is that you want to ");
		manip_type(manip,1);
		printf(".\n");
		flg_ptr->prompt = YES;
		misc[0] = -1;
		return;
	}
	get_classes(flg_ptr,classes,obj_ref);
	in_a_container = NO;
	if (classes[CONTAINER][0] != 0 && obj_ref[CONTAINER] != -1){
		type = CONTAINER;
		if (inv_ptr->first != 0) {
			obj_num[type] = inv_ptr->first;
			strcpy(move_these,is_it_here(type,classes,known,near_miss,obj_ref,obj_num));
		}
		if (move_these[0] == 0 && rooms[flg_ptr->room_num].first_obj != 0) {
			obj_num[type] = rooms[flg_ptr->room_num].first_obj;
			strcpy(move_these,is_it_here(type,classes,known,near_miss,obj_ref,obj_num));
		}
		if (move_these[0] != 0) {
			in_a_container = YES;
			obj_num[CONTAINER] = atoi(strtok(move_these,","));
		} else {
			manip_error(manip,CONTAINER,classes,known,near_miss,obj_ref);
			misc[0] = -1;
			flg_ptr->prompt = YES;
			return;
		}
		if (objects[obj_num[CONTAINER]].contains_inside == NULL || !objects[obj_num[CONTAINER]].open_state) {
			printf("Don't be silly. How can you ");
			manip_type(manip,4);
			if (!objects[obj_num[CONTAINER]].open_state) {
				printf(" a closed");
				printf(" %s?\n",objects[obj_num[CONTAINER]].noword);
			} else
				printf(" %s?\n",objects[obj_num[CONTAINER]].aword);
			flg_ptr->prompt = YES;
			misc[0] = -1;
			return;
		}
	}
	type = OBJECT;
	if(in_a_container) {
		if (manip == TAKE_OBJ)
			obj_num[OBJECT] = objects[obj_num[CONTAINER]].contains_inside->first;
		else if (manip == DROP_OBJ || manip == EMPTY_OBJ)
			obj_num[OBJECT] = inv_ptr->first;
	} else {
		if (manip == TAKE_OBJ)
			obj_num[OBJECT] = rooms[flg_ptr->room_num].first_obj;
		else if (manip != WHERE_OBJ)
			obj_num[OBJECT] = inv_ptr->first;
	}
		strcpy(move_these,is_it_here(type,classes,known,near_miss,obj_ref,obj_num));


	if (manip == TAKE_OBJ && strlen(move_these) == 0) {   /* -+- */
		tmp_next = inv_ptr->first;
		do {
			while (tmp_next) {
				if (objects[tmp_next].contains_inside != NULL && objects[tmp_next].contains_inside->first != 0 && objects[tmp_next].open_state) {
					obj_num[OBJECT] = objects[tmp_next].contains_inside->first;
					strcat(move_these,is_it_here(type,classes,known,near_miss,obj_ref,obj_num));
				}
				if (strlen(move_these) == 0)
					tmp_next = objects[tmp_next].next_obj;
				else {
					in_a_container = YES;
					obj_num[CONTAINER] = tmp_next;
					tmp_next = 0;
				}
			}
			if (strlen(move_these) == 0)
				tmp_next = rooms[flg_ptr->room_num].first_obj;
		} while (tmp_next);
		
	}
	if ((manip == OPEN_OBJ || manip == CLOSE_OBJ || manip == EXAMINE_OBJ)) {
		obj_num[OBJECT] = rooms[flg_ptr->room_num].first_obj;
		strcat(move_these,is_it_here(type,classes,known,near_miss,obj_ref,obj_num));
	}
	if (manip != DROP_OBJ && manip != WEIGH_OBJ && !in_a_container && strlen(rooms[flg_ptr->room_num].multi_room_objs) > 1) {
		if ((multi_string = farmalloc(strlen(rooms[flg_ptr->room_num].multi_room_objs))) == NULL)
			error(304);
		strcpy(multi_string,rooms[flg_ptr->room_num].multi_room_objs);
		if ((multi_ptr = strtok(multi_string,",")) == NULL)
			multi_ptr = 0;
		obj_num[type] = atoi(multi_ptr);
		if (atoi(multi_ptr) != 0) {
			length = strlen(multi_ptr);
			multi_string [strlen(multi_ptr)] = '|';
			strrev(multi_string);
			length2 = strlen(multi_string);
			length = length2 - ++length;
			multi_string [length] = '\0';
			strrev(multi_string);
		}
		while (obj_num[type]) {
			strcat(move_these,is_it_here(type,classes,known,near_miss,obj_ref,obj_num));
			if ((multi_ptr = strtok(multi_string,",")) == NULL)
				multi_ptr = "0";
                        obj_num[type] = atoi(multi_ptr);
                	length = strlen(multi_ptr);
			multi_string [strlen(multi_ptr)] = '|';
			strrev(multi_string);
                        length2 = strlen(multi_string);
			length = length2 - ++length;
			if (length >= 0)
				multi_string [length] = '\0';
			else
				multi_string [0] = '\0';
			strrev(multi_string);
		}
	}
	if (manip == WHERE_OBJ) {
		strcpy(move_these,"");
		for (count = 1; count<=OBJ_NO;count++) {
			if (!objects[count].feature) {
				obj_num[OBJECT] = count;
				tmp_next = objects[obj_num[OBJECT]].next_obj;
				objects[obj_num[OBJECT]].next_obj = 0;
				strcat(move_these,is_it_here(type,classes,known,near_miss,obj_ref,obj_num));
				objects[count].next_obj = tmp_next;
			}
		}
	}
	misc[0] = in_a_container;
	misc[1] = obj_count;
}
