/******************************************************/
/*         ROOMS - A room 'hanging' utility.          */
/*         V 1.7                                      */
/*         (c) October 1989. L.F. Holgate             */
/*                                                    */
/*         Command parsing.    			      */
/*                                                    */
/******************************************************/

#include <stdio.h>
#include <alloc.h>
#include <ctype.h>
#include <string.h>
#include <ctype.h>
#include "rooms17.h"
#include "player.h"

extern struct rm_file rooms[MAX_ROOMS];
extern struct vo_file vocab[MAX_WORDS];
extern struct obj objects[MAX_OBJECTS];

extern	char *get_buffer(FILE *fp,int type);

void	process_command (struct flgs *flg_ptr, char command []);

char 	*get_new_command (void),
	*get_command (char *command_buffer);

void process_command (struct flgs *flg_ptr,char command [])
{
	int 	known, count, other_count, length, code[2];
	char    tmp_cmd [COMMAND_LENGTH], *cmd, *cmd2;


	strcpy(tmp_cmd,command);
	if ((cmd = strtok(tmp_cmd," ")) == NULL)
		cmd = ",";
	other_count = 0;
	do {
        	length = strlen(cmd);
		if ((cmd2 = farmalloc(length+2)) == NULL)
			error(1001);
		strcpy(cmd2,cmd);
		if (cmd[length - 1] == 's')
			cmd2[length - 1] = '\0';
		else
			cmd2[0] = '\0';
		known = NO;
		if (atoi(cmd) || cmd[0] == '0') {
			known = YES;
			code[0] = 0;
			code[1] = atoi(cmd);
		} else {
			for (count = 0; (vocab [count].word != NULL) && (!known); count++) {
				if (!strcmp(cmd,vocab [count].word)) {
					known = YES;
					code[0] = vocab [count].command_code[0];
					code[1] = vocab [count].command_code[1];
					if ((other_count < 2 && code[0] == 3) || (other_count != 0 && code[0] == 2) || (other_count > 1 && code[0] == 1))
							known = NO;
				} else if (cmd2[0] != '\0' && !known) {
					if (!strcmp(cmd2,vocab [count].word)) {
					known = YES;
					code[0] = vocab [count].command_code[0];
					code[1] = vocab [count].command_code[1];
					if ((other_count < 2 && code[0] == 3) || (other_count != 0 && code[0] == 2))
							known = NO;
					}
				}
			}
                }
                farfree(cmd2);
		if (!known) {
			puts("You want to do what?");
			code[0] = code[1] = -1;
			for (; other_count >= 0; other_count--) {
				flg_ptr->commands[other_count][0] = flg_ptr->commands[other_count][1] = -1;
			}
			flg_ptr->prompt = YES;
			break;
		}
		flg_ptr->commands[other_count][0] = code[0];
		flg_ptr->commands[other_count][1] = code[1];
		if (other_count < COMMAND_LIMIT) {
			flg_ptr->commands[other_count+1][0] = -1;
			flg_ptr->commands[other_count+1][1] = -1;
		}
		other_count++;
		if ((cmd = strtok(NULL," ")) == NULL)
			break;
	} while (other_count <= 10);
}


char *get_command (char command_buffer [])
{
	int 	length;
	char 	*cmd_ptr, tmp_cmd_buf [COMMAND_LENGTH],
		command [COMMAND_LENGTH];

	strcpy (tmp_cmd_buf,command_buffer);
	command [0] = 0;
	if ((cmd_ptr = (strtok(tmp_cmd_buf,COMMAND_DELIMITERS))) == NULL)
		cmd_ptr = ",";
	length = strlen(strcpy(command,cmd_ptr));
	length = strlen(command_buffer) - ++length;
	if (command_buffer != '\0') {
		strrev(command_buffer);
		command_buffer [length] = '\0';
		length = strlen(command_buffer);
		while (command_buffer[--length] == ',')
			command_buffer[length] = '\0';
		strrev(command_buffer);
	}
	return (command);
}

char *get_new_command (void)
{
	char 	new_command [BUFFER_SIZE];

	strcpy(new_command,get_buffer(stdin,10));
	strlwr(new_command);
	return(new_command);
}
