/******************************************************/
/*         ROOMS - A room 'hanging' utility.          */
/*         V 1.7                                      */
/*         (c) October 1989. L.F. Holgate             */
/*                                                    */
/*         Header file.                               */
/*                                                    */
/******************************************************/

#define MAX_OBJECTS    200
#define MAX_ROOMS      200
#define MAX_WORDS      350
#define MAX_MESSAGE 	30
#define BUFFER_SIZE   1500
#define COMMAND_LENGTH 100
#define COMMAND_LIMIT   10
#define OBJ_STR_LENGTH 400

#define SDESC           0
#define LDESC           1
#define EXITS           2
#define DOORS           3
#define COORDS          3
#define BRIEF           0
#define VERBOSE         1
#define OFF             0
#define ON              1
#define NO              0
#define YES             1
#define WORD            0
#define ROOM            0
#define CONTAINER       1
#define HELD            2
#define MULTI_ROOM      3
#define WORN		4
#define OPEN            1
#define CLOSED          0
#define LOCKED          1
#define UNLOCKED        0
#define FEATURE         3
#define ROOM_FILE       rooms[0].sdesc
#define ROOM_TITLE      rooms[0].ldesc
#define ROOM_TYPE       rooms[0].exits
#define ROOM_NO         rooms[0].x_coord
#define OBJ_NO          objects[0].mass
#define TINY_OBJ        1
#define OBJECT          0
#define CONTAINER       1
#define NEW_FIRST       first_last[OBJECT][0]
#define NEW_LAST        first_last[OBJECT][1]
#define OLD_FIRST       first_last[CONTAINER][0]
#define OLD_LAST        first_last[CONTAINER][1]
#define TAKE_OBJ        0
#define DROP_OBJ        1
#define OPEN_OBJ        2
#define CLOSE_OBJ       3
#define EMPTY_OBJ	4
#define WHERE_OBJ	5
#define WEIGH_OBJ	6
#define EXAMINE_OBJ	7

#define COMMAND_DELIMITERS    ",./\\;:+"
#define PROMPT                ">"
#define LINE_LENGTH     80

#define MOVE_CMD        (flag.commands [0] [0] == 1 || (flag.commands [0] [0] == 2 && flag.commands [0] [1] == 10 && flag.commands [1] [0] == 1))
#define LOOK_CMD        (cmd_code[0] == 2 && (cmd_code[1] == 1 || cmd_code[1] == 2))
#define BRIEF_TOGGLE    (cmd_code[0] == 2 && (cmd_code[1] == 3 || cmd_code[1] == 4))
#define SCORE_CMD       (cmd_code[0] == 2 && (cmd_code[1] == 5 || cmd_code[1] == 6))
#define QUIT_CMD        (cmd_code[0] == 2 && cmd_code[1] == 7)
#define EXITS_CMD       (cmd_code[0] == 2 && cmd_code[1] == 8)
#define DEBUG_TOGGLE    (cmd_code[0] == 2 && cmd_code[1] == 9)
#define MAGICAL_CMD     (cmd_code[0] == 2 && cmd_code[1] == 10)
#define HELP_CMD        (cmd_code[0] == 2 && cmd_code[1] == 12)
#define GET_CMD         (cmd_code[0] == 2 && cmd_code[1] == 13)
#define INV_CMD         (cmd_code[0] == 2 && cmd_code[1] == 14)
#define DROP_CMD        (cmd_code[0] == 2 && cmd_code[1] == 15)
#define OPEN_CMD        (cmd_code[0] == 2 && cmd_code[1] == 16)
#define CLOSE_CMD       (cmd_code[0] == 2 && cmd_code[1] == 17)
#define EMPTY_CMD 	(cmd_code[0] == 2 && cmd_code[1] == 18)
#define WHERE_CMD	(cmd_code[0] == 2 && cmd_code[1] == 20)
#define WEIGH_CMD	(cmd_code[0] == 2 && cmd_code[1] == 21)
#define EXAMINE_CMD	(cmd_code[0] == 2 && cmd_code[1] == 22)
#define WHO_CMD		(cmd_code[0] == 2 && cmd_code[1] == 23)
#define TOUCH_CMD	(cmd_code[0] == 2 && cmd_code[1] == 24)

#define UP_ARROW        72
#define DOWN_ARROW      80
#define RETURN          13
#define BELL            7

struct rm_file {
        char    *sdesc, *ldesc, *exits, *doors, *multi_room_objs;
        int     x_coord, y_coord, z_coord, first_obj, last_obj;
        } ;

struct vo_file {
        char    *word;
        int     command_code[2];
        } ;

struct flgs {
        int     room_num, old_num, moved, prompt, can_see, brief_state,
                debug_state, commands [COMMAND_LIMIT+1] [2];
        } ;

struct inv {
        int     first, last;
        } ;

struct door_obj {
	int     bar_side, other_room;
unsigned int    barable: 1, bar_state: 1, spikeable: 1, spike_state: 1,
                hidden_state: 2, hidden_side: 2, open_side: 2;
	} ;

struct container_obj {
	int     first, last, max_siz, max_obj, contained_siz, contained_obj;
unsigned long	max_wt, contained_wt;
        } ;

struct obj {
	char	*name, *desc, *mdesc, *ldesc, *aword, *theword, *noword,
		*multi, *type, *multi_room;
	int     size, next_obj, prev_obj, loc_type, location;
unsigned long	mass;
unsigned int    feature: 1, mid_desc: 1, openable: 1,
		open_state: 1, lockable: 1, lock_state: 1;
struct container_obj 	*contains_inside,
			*contains_on_top,
			*contains_below;
struct door_obj		*is_a_door;
	} ;

